Index: trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/include/vci_cc_xcache_wrapper_v4.h
===================================================================
--- trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/include/vci_cc_xcache_wrapper_v4.h	(revision 83)
+++ trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/include/vci_cc_xcache_wrapper_v4.h	(revision 90)
@@ -52,8 +52,8 @@
     : public soclib::caba::BaseModule
 {
-    typedef sc_dt::sc_uint<40> addr_40;
-    typedef uint32_t    data_t;
-    typedef uint32_t    tag_t;
-    typedef uint32_t    be_t;
+    typedef sc_dt::sc_uint<40> 	addr_40;
+    typedef uint32_t    	data_t;
+    typedef uint32_t    	tag_t;
+    typedef uint32_t    	be_t;
     typedef typename vci_param::fast_addr_t vci_addr_t;
     enum dcache_fsm_state_e {
@@ -194,5 +194,5 @@
 
     sc_signal<int>          r_vci_tgt_fsm;
-    sc_signal<addr_40>       r_tgt_addr;
+    sc_signal<addr_40>      r_tgt_addr;
     sc_signal<size_t>       r_tgt_word;
     sc_signal<bool>         r_tgt_update;
@@ -274,4 +274,5 @@
     ~VciCcXCacheWrapperV4();
 
+    void print_trace();
     void print_cpi();
     void print_stats();
Index: trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp
===================================================================
--- trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 83)
+++ trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 90)
@@ -64,5 +64,4 @@
 namespace caba {
 
-#if DEBUG_CC_XCACHE_WRAPPER
     namespace {
         const char *dcache_fsm_state_str[] = {
@@ -126,5 +125,4 @@
         };
     }
-#endif
 
 #define tmpl(...)  template<typename vci_param, typename iss_t> __VA_ARGS__ VciCcXCacheWrapperV4<vci_param, iss_t>
@@ -134,5 +132,5 @@
     /////////////////////////////////
     tmpl(/**/)::VciCcXCacheWrapperV4(
-            /////////////////////////////////
+    /////////////////////////////////
             sc_module_name name,
             int proc_id,
@@ -248,5 +246,5 @@
     ///////////////////////////////////
     tmpl(/**/)::~VciCcXCacheWrapperV4()
-        ///////////////////////////////////
+    ///////////////////////////////////
     {
         delete [] r_icache_miss_buf;
@@ -258,5 +256,5 @@
     ////////////////////////
     tmpl(void)::print_cpi()
-        ////////////////////////
+    ////////////////////////
     {
         std::cout << "CPU " << m_srcid_rw << " : CPI = " 
@@ -265,5 +263,5 @@
     ////////////////////////
     tmpl(void)::print_stats()
-        ////////////////////////
+    ////////////////////////
     {
         float run_cycles = (float)(m_cpt_total_cycles - m_cpt_frz_cycles);
@@ -287,8 +285,24 @@
         std::cout << "- WRITE LENGTH       = " << (float)m_length_write_transaction/m_cpt_write_transaction << std::endl;
     }
-
+    /////////////////////////
+    tmpl(void)::print_trace()
+    /////////////////////////
+    {
+        typename iss_t::InstructionRequest  ireq;
+        typename iss_t::DataRequest         dreq;
+        m_iss.getRequests( ireq, dreq );
+
+        std::cout << std::dec << "CC_XCACHE_WRAPPER " << m_srcid_rw << std::endl;
+        std::cout << " cache state : " << icache_fsm_state_str[r_icache_fsm] << " / "
+                                       << dcache_fsm_state_str[r_dcache_fsm] << " / "
+                                       << cmd_fsm_state_str[r_vci_cmd_fsm] << " / "
+                                       << rsp_fsm_state_str[r_vci_rsp_fsm] << " / "
+                                       << tgt_fsm_state_str[r_vci_tgt_fsm] << std::endl;
+        std::cout << " proc state : PC = " << ireq.addr << " / AD = " << dreq.addr 
+                                       << " / V = " << dreq.valid << " TYPE = " << dreq.type << std::endl;
+    }
     //////////////////////////
     tmpl(void)::transition()
-        //////////////////////////
+    //////////////////////////
     {
         if ( ! p_resetn.read() ) {
@@ -1644,5 +1658,5 @@
     //////////////////////////////////////////////////////////////////////////////////
     tmpl(void)::genMoore()
-        //////////////////////////////////////////////////////////////////////////////////
+    //////////////////////////////////////////////////////////////////////////////////
     {
         // VCI initiator response